/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, 2009, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#include <o2scl/funct.h>
#include <o2scl/test_mgr.h>

using namespace std;
using namespace o2scl;

int func(double x, double &y, double &pa) {
  y=pa+x;
  return 0;
}

class ac {
public:
  int mfunc(double x, double &y, double &pa) {
    y=pa+x;
    return 0;
  }
};

int main(void) {
  test_mgr t;
  t.set_output_level(2);

  collection co;

  funct_fptr<double> f1(func);
  double a=2.0;
  ovector_array aa(1,&a);
  double x=3.2, y;

  y=0.0;
  f1(x,y,a);
  t.test_rel(y,5.2,1.0e-6,"fptr");

  y=0.0;
  ac c1;
  funct_mfptr<ac,double> f3(&c1,&ac::mfunc);
  f3(x,y,a);
  t.test_rel(y,5.2,1.0e-6,"mfptr");
  
  t.report();
  return 0;
}

